Loading...
Searching...
No Matches
Opm::EclWriter< TypeTag, OutputModule > Class Template Reference

Collects necessary output values and pass it to opm-common's ECL output. More...

`#include <EclWriter.hpp>`

Inheritance diagram for Opm::EclWriter< TypeTag, OutputModule >:

## Public Member Functions

| EclWriter (Simulator &simulator)
const EquilGrid & | globalGrid () const
void | evalSummaryState (bool isSubStep)
| collect and pass data and pass it to eclIO writer
void | writeInitialFIPReport ()
| Writes the initial FIP report as configured in RPTSOL.
void | writeReports (const SimulatorTimer &timer)
void | writeOutput (data::Solution &&localCellData, bool isSubStep)
void | beginRestart ()
void | endRestart ()
const OutputModule & | outputModule () const
OutputModule & | mutableOutputModule () const
Scalar | restartTimeStepSize () const
template<class Serializer>
void | serializeOp (Serializer &serializer)
Public Member Functions inherited from Opm::EclGenericWriter< GetPropType< TypeTag, Properties::Grid >, GetPropType< TypeTag, Properties::EquilGrid >, GetPropType< TypeTag, Properties::GridView >, GetPropType< TypeTag, Properties::ElementMapper >, GetPropType< TypeTag, Properties::Scalar > >
| EclGenericWriter (const Schedule &schedule, const EclipseState &eclState, const SummaryConfig &summaryConfig, const Grid &grid, const EquilGrid *equilGrid, const GridView &gridView, const Dune::CartesianIndexMapper< Grid > &cartMapper, const Dune::CartesianIndexMapper< EquilGrid > *equilCartMapper, bool enableAsyncOutput, bool enableEsmry)
const EclipseIO & | eclIO () const
void | writeInit ()
void | setTransmissibilities (const TransmissibilityType *globalTrans)
void | setSubStepReport (const SimulatorReportSingle &report)
void | setSimulationReport (const SimulatorReport &report)
const std::vector< NNCdata > & | getOutputNnc () const
const CollectDataOnIORankType & | collectOnIORank () const
void | extractOutputTransAndNNC (const std::function< unsigned int(unsigned int)> &map)

## Static Public Member Functions

static void | registerParameters ()

## Additional Inherited Members

Protected Member Functions inherited from Opm::EclGenericWriter< GetPropType< TypeTag, Properties::Grid >, GetPropType< TypeTag, Properties::EquilGrid >, GetPropType< TypeTag, Properties::GridView >, GetPropType< TypeTag, Properties::ElementMapper >, GetPropType< TypeTag, Properties::Scalar > >
const TransmissibilityType & | globalTrans () const
unsigned int | gridEquilIdxToGridIdx (unsigned int elemIndex) const

void

doWriteOutput (const int reportStepNum, const std::optional< int > timeStepNum, const bool isSubStep, data::Solution &&localCellData, data::Wells &&localWellData, data::GroupAndNetworkValues &&localGroupAndNetworkData, data::Aquifers &&localAquiferData, WellTestState &&localWTestState, const Action::State &actionState, const UDQState &udqState, const SummaryState &summaryState, const std::vector< Scalar > &thresholdPressure, Scalar curTime, Scalar nextStepSize, bool doublePrecision, bool isFlowsn, std::array< FlowsData< double >, 3 > &&flowsn, bool isFloresn, std::array< FlowsData< double >, 3 > &&floresn)

void

evalSummary (int reportStepNum, Scalar curTime, const data::Wells &localWellData, const data::WellBlockAveragePressures &localWBPData, const data::GroupAndNetworkValues &localGroupAndNetworkData, const std::map< int, data::AquiferData > &localAquiferData, const std::map< std::pair< std::string, int >, double > &blockData, const std::map< std::string, double > &miscSummaryData, const std::map< std::string, std::vector< double > > &regionData, const Inplace &inplace, const std::optional< Inplace > &initialInPlace, const InterRegFlowMap &interRegFlows, SummaryState &summaryState, UDQState &udqState)

Protected Attributes inherited from Opm::EclGenericWriter< GetPropType< TypeTag, Properties::Grid >, GetPropType< TypeTag, Properties::EquilGrid >, GetPropType< TypeTag, Properties::GridView >, GetPropType< TypeTag, Properties::ElementMapper >, GetPropType< TypeTag, Properties::Scalar > >
CollectDataOnIORankType | collectOnIORank_
const Grid & | grid_
const GridView & | gridView_
const Schedule & | schedule_
const EclipseState & | eclState_
std::unique_ptr< EclipseIO > | eclIO_
std::unique_ptr< TaskletRunner > | taskletRunner_
Scalar | restartTimeStepSize_
const TransmissibilityType * | globalTrans_
const Dune::CartesianIndexMapper< Grid > & | cartMapper_
const Dune::CartesianIndexMapper< EquilGrid > * | equilCartMapper_
const EquilGrid * | equilGrid_
SimulatorReportSingle | sub_step_report_
SimulatorReport | simulation_report_
std::vector< NNCdata > | outputNnc_
std::unique_ptr< data::Solution > | outputTrans_

## Detailed Description

template<class TypeTag, class OutputModule>
class Opm::EclWriter< TypeTag, OutputModule >

Collects necessary output values and pass it to opm-common's ECL output.

Caveats:

- For this class to do do anything meaningful, you will have to have the OPM module opm-common with ECL writing enabled.
- The only DUNE grid which is currently supported is Dune::CpGrid from the OPM module "opm-grid". Using another grid won't fail at compile time but you will provoke a fatal exception as soon as you try to write an ECL output file.
- This class requires to use the black oil model with the element centered finite volume discretization.

The documentation for this class was generated from the following file:

- opm/simulators/flow/EclWriter.hpp